; Source created with Parsic Version 3.x

; at              : 09/01/03 15.50.59


; Project File    : c:\PROGRA~1\PARSIC\CICLO2MO\CICLO2MO\CICLO2MO.PIC

; Project Version : 1.0.25

; Created         : 16/08/02 14.51.00

; Last change     : 09/01/03 15.47.14

	PROCESSOR 12CE518

	INCLUDE P12CE518.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_ON & _WDT_ON & _INTRC_OSC & _MCLRE_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag
#DEFINE RETURN RETLW 0


; Variable

S0	= 7	; located in Bank 0
OS1_FD	= 8	; located in Bank 0
OS2_FD	= 9	; located in Bank 0
SYS_OLDTMR0	= 10	; located in Bank 0
TR1	= 11	; located in Bank 0
TR1_HI	= 12	; located in Bank 0
ZV1	= 13	; located in Bank 0
ZV1_HI	= 14	; located in Bank 0
ZV1_FD	= 15	; located in Bank 0
S1	= 16	; located in Bank 0
OS3_FD	= 17	; located in Bank 0
ZV2	= 18	; located in Bank 0
ZV2_HI	= 19	; located in Bank 0
ZV2_FD	= 20	; located in Bank 0
OS4_FD	= 21	; located in Bank 0
MF1	= 22	; located in Bank 0
MF1_HI	= 23	; located in Bank 0
MF2	= 24	; located in Bank 0
MF2_HI	= 25	; located in Bank 0
RAM	= 26	; located in Bank 0

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF FSR
	MOVWF OSCCAL
	GOTO SYS_INIT

;****************************************
;Interrupt-Adress
;****************************************

SYS_INTERRUPT
	MOVFW SYS_OLDTMR0
	SUBWF TMR0,W
	BTFSS STATUS,CARRY
	GOTO SYS_INTERRUPT_START
	ADDWF SYS_OLDTMR0,F
	RETURN

SYS_INTERRUPT_START
	ADDWF SYS_OLDTMR0,F

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_1
	INCF MF1_HI,F

SYS_INT_LABEL_1
	INCFSZ MF2,F
	GOTO SYS_INT_LABEL_2
	INCF MF2_HI,F

SYS_INT_LABEL_2

EXITINT
	RETURN

;****************************************
; Subroutines
;****************************************


;****************************************
; Tables
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT


; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	MOVLW B'00000000'
	MOVWF GPIO

	MOVLW 79
	OPTION


; Richtung setzen

	MOVLW B'11001011'
	TRIS GPIO

; init vars


; Clear RAM

	MOVLW 7
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS STATUS,ZERO
	GOTO CR1


	CLRF TMR0

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS GPIO,0
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,0
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF S0,0
	BTFSC GPIO,0
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S0,0
	GOTO LABEL_RS1_RESET
	BTFSS S0,1
	GOTO LABEL_RS1_ENDE
	BSF GPIO,5	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF GPIO,5	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; One Shot -> OS2
;***************************************************


	BTFSS GPIO,1
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S0,1
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF S0,1
	BTFSC GPIO,1
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 161
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,6
	GOTO LABEL_TR1_CLR
	BSF S0,6
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,6
LABEL_TR1_ENDE

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Zhler -> ZV1
;***************************************************

	BTFSS S0,2	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	CLRF ZV1_HI
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BTFSS S0,7
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC S0,5	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCFSZ ZV1,F
	GOTO LABEL_ZV1_SETOUT
	INCF ZV1_HI,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	DECF ZV1,F
	INCFSZ ZV1,W
	GOTO LABEL_ZV1_SETOUT
	DECF ZV1_HI,F

LABEL_ZV1_SETOUT


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BTFSC S0,7
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW HIGH 43200
	SUBWF ZV1_HI,W	; F - W -> W

	BTFSS STATUS,ZERO	; Wenn ZERO gesetzt LOW-Byte testen
	GOTO LABEL_IF1_CHECK
	MOVLW LOW 43200
	SUBWF ZV1,W	; F - W -> W

LABEL_IF1_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S0,2
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S0,2

LABEL_IF1_EXIT
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; GND
;***************************************************

	BCF S0,5	; immer Low

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS GPIO,5
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S0,4
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S1,5
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF S1,5
LABEL_LG1_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BTFSC S0,2
	GOTO LABEL_RS2_RESET
	BTFSS S0,3
	GOTO LABEL_RS2_ENDE
	BSF S0,4	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF S0,4	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; One Shot -> OS3
;***************************************************


	BTFSS GPIO,5
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S1,4
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF S1,4
	BTFSC GPIO,5
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS S0,6
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BTFSS GPIO,5
	GOTO LABEL_LG2_FALSE
LABEL_LG2_3
	BTFSC S1,0
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF S0,7
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF S0,7
LABEL_LG2_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; RS-FLIP-FLOP -> RS3
;***************************************************

	BTFSC S1,2
	GOTO LABEL_RS3_RESET
	BTFSS S0,2
	GOTO LABEL_RS3_ENDE
	BSF S1,0	; Ausgang setzen
	GOTO LABEL_RS3_ENDE
LABEL_RS3_RESET
	BCF S1,0	; Ausgang zurcksetzen
LABEL_RS3_ENDE

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSS S1,0
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BTFSS S0,6
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S1,1
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF S1,1
LABEL_LG3_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Zhler -> ZV2
;***************************************************

	BTFSS S1,2	; Reset ?
	GOTO LABEL_ZV2_COUNT
	CLRF ZV2
	CLRF ZV2_HI
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_COUNT

; Test auf positive Flanke

	BTFSS S1,1
	GOTO LABEL_ZV2_SETFD
	BTFSC ZV2_FD,0
	GOTO LABEL_ZV2_SETFD

	BSF ZV2_FD,0


	BTFSC S1,6	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV2_BACKWARD

	INCFSZ ZV2,F
	GOTO LABEL_ZV2_SETOUT
	INCF ZV2_HI,F
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_BACKWARD
	DECF ZV2,F
	INCFSZ ZV2,W
	GOTO LABEL_ZV2_SETOUT
	DECF ZV2_HI,F

LABEL_ZV2_SETOUT


LABEL_ZV2_SETFD

; Test auf negative Flanke

	BTFSC S1,1
	GOTO LABEL_ZV2_EXIT
	BCF ZV2_FD,0

LABEL_ZV2_EXIT

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW HIGH 43200
	SUBWF ZV2_HI,W	; F - W -> W

	BTFSS STATUS,ZERO	; Wenn ZERO gesetzt LOW-Byte testen
	GOTO LABEL_IF2_CHECK
	MOVLW LOW 43200
	SUBWF ZV2,W	; F - W -> W

LABEL_IF2_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S1,2
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S1,2

LABEL_IF2_EXIT
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; One Shot -> OS4
;***************************************************


	BTFSC S1,0
	GOTO LABEL_OS4_1
	BTFSC OS4_FD,0
	GOTO LABEL_OS4_1
	BSF OS4_FD,0
	BSF S1,3
	GOTO LABEL_OS4_2
LABEL_OS4_1
	BCF S1,3
	BTFSS S1,0
	GOTO LABEL_OS4_2
	BCF OS4_FD,0
LABEL_OS4_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; ODER - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSC S1,4
	GOTO LABEL_LG4_TRUE
LABEL_LG4_2
	BTFSC S1,3
	GOTO LABEL_LG4_TRUE

LABEL_LG4_FALSE
	BCF S0,3
	GOTO LABEL_LG4_ENDE
LABEL_LG4_TRUE
	BSF S0,3
LABEL_LG4_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BTFSC S1,5	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF GPIO,4
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BTFSC GPIO,4	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 76
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 75
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF GPIO,4
LABEL_MF1_EXIT

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Anzug-Verzgerung -> MF2
;***************************************************

	BTFSC S1,0	; Eingang auf High ?
	GOTO LABEL_MF2_CHKTIME	; Ja

; RESET

	CLRF MF2
	CLRF MF2_HI
	BCF GPIO,2
	GOTO LABEL_MF2_EXIT	; raus

LABEL_MF2_CHKTIME

	BTFSC GPIO,2	; Ausgang schon auf High ?
	GOTO LABEL_MF2_EXIT	; Ja

	MOVLW 76
	SUBWF MF2_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	MOVLW 75
	SUBWF MF2,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	BSF GPIO,2
LABEL_MF2_EXIT

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; GND
;***************************************************

	BCF S1,6	; immer Low

;****************************************

	GOTO MAIN

	ORG 511

	MOVLW H'05'	; OSCCAL

	END

